package cn.iocoder.yudao.module.rescue.mapper;


import cn.hutool.core.date.DateTime;
import cn.iocoder.yudao.module.rescue.domain.DriverInfo;
import cn.iocoder.yudao.module.rescue.domain.RescueInfo;
import cn.iocoder.yudao.module.rescue.dto.DriverInfo2Dto;
import cn.iocoder.yudao.module.rescue.dto.DriverInfoDto;
import cn.iocoder.yudao.module.rescue.vo.BuckleVO;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;

/**
 * 【请填写功能名称】Mapper接口
 *
 * @author ruoyi
 * @date 2023-07-14
 */
@Mapper
public interface RescueInfoMapper extends BaseMapper<RescueInfo>
{

    /**
     * 查询【请填写功能名称】列表
     *
     * @param rescueInfo 【请填写功能名称】
     * @return 【请填写功能名称】集合
     */
    IPage<RescueInfo> selectRescueInfoList(@Param("map") RescueInfo rescueInfo, Page<RescueInfo> page);

    IPage<RescueInfo> selectRescueListSystem2(@Param("map") RescueInfo rescueInfo, Page<RescueInfo> page);

    JSONObject listData(RescueInfo rescueInfo);
    /**
     * 查询【请填写功能名称】列表
     *
     * @param rescueInfo 【请填写功能名称】
     * @return 【请填写功能名称】集合
     */
    IPage<RescueInfo> selectRescueInfoListApp(@Param("map") RescueInfo rescueInfo, Page<RescueInfo> page);
    IPage<RescueInfo> getKcList(@Param("map") RescueInfo rescueInfo, Page<RescueInfo> page);



    IPage<DriverInfo> driverList(@Param("map") DriverInfoDto user, Page<DriverInfo> page);
    List<DriverInfo2Dto> driverListApp(DriverInfoDto user);
    Map<String,Integer> driverInMap2();
    void dealOverTimeRescue();
    List<RescueInfo> getOverTimeRescue();
    Map<String,Object> getRescueStatistics(RescueInfo rescueInfo);
    Map<String,Object> getRescueStatisticsByAdmin(@Param("map") RescueInfo rescueInfo);
    void deleteOtherInfo1(@Param("rescueId") Long rescueId);
    void deleteOtherInfo2(@Param("rescueId") Long rescueId);

    JSONObject getDriverCarNum(@Param("driverId") Long driverId,@Param("carNum") String carNum,@Param("time") String time);
    IPage<RescueInfo>  getRescueInfoByDriver(@Param("map") RescueInfo rescueInfo, Page<RescueInfo> page);
    List<JSONObject> statisticsInfo(@Param("startTime")String startTime,@Param("endTime")String endTime);

    /**
     * 获取扣车单位和具体数量
     * @author 小李
     * @date 10:46 2024/9/5
     **/
    List<BuckleVO> listBuckle();

    List<Map<String, Object>> selectManageAnalyze(@Param("startTime") DateTime startTime,@Param("endTime") DateTime endTime,@Param("tenantId") Long tenantId);

    /**
     * 获取司机排序
     * @param startTime
     * @param endTime
     * @return
     */
    List<Map<String, Object>> selectDriverSort(@Param("startTime") DateTime startTime,@Param("endTime") DateTime endTime);

    /**
     * 救援大屏获取救援订单占比接口
     * @param dictType
     * @return
     */
    List<Map<String, Object>> selectRescueOrderByRoad(String dictType);
}
